Index: issm/trunk/src/c/objects/Bamg/QuadTree.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/QuadTree.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/QuadTree.h	(revision 3913)
@@ -0,0 +1,65 @@
+/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, QuadTree.h)*/
+#ifndef _QUADTREE_H
+#define _QUADTREE_H
+
+#include "./include.h"
+
+namespace bamg {
+
+	const int  MaxDeep = 30;
+	const long MaxISize = ( 1L << MaxDeep); 
+
+	class Triangles;
+	class MeshVertex;
+
+	class QuadTree{
+		private:
+			class QuadTreeBox { 
+				public:
+					long n; 
+					//contains only one object form the list (either MeshVertex or QuadTreeBox)
+					// if n < 4 => MeshVertex else =>  QuadTreeBox;
+					union{
+						QuadTreeBox* b[4];
+						MeshVertex* v[4];
+					};
+			};
+			class StorageQuadTreeBox {
+				public:
+					QuadTreeBox *b,*bc,*be;
+					long len;
+					StorageQuadTreeBox* n; // next StorageQuadTreeBox
+					StorageQuadTreeBox(long ,StorageQuadTreeBox* =NULL);
+					~StorageQuadTreeBox() {
+						if(n) delete n;
+						delete [] b;
+					}
+					long  SizeOf() const {return len*sizeof(QuadTreeBox)+sizeof(StorageQuadTreeBox)+ (n?n->SizeOf():0);}
+			};
+			StorageQuadTreeBox* sb;
+			long                lenStorageQuadTreeBox;
+
+		public:
+			//fields
+			QuadTreeBox* root;
+			Triangles*   th;
+			//functions
+			~QuadTree();
+			QuadTree(Triangles * t,long nbv=-1);
+			QuadTree();
+			long    NbQuadTreeBox,NbVertices;
+			long    NbQuadTreeBoxSearch,NbVerticesSearch;
+			MeshVertex* NearestVertex(Icoor1 i,Icoor1 j);
+			MeshVertex* NearestVertexWithNormal(Icoor1 i,Icoor1 j);
+			MeshVertex* ToClose(MeshVertex & ,double ,Icoor1,Icoor1);
+			long    SizeOf() const {return sizeof(QuadTree)+sb->SizeOf();}
+			void    Add( MeshVertex & w);
+			QuadTreeBox* NewQuadTreeBox(){
+				if(! (sb->bc<sb->be)) sb=new StorageQuadTreeBox(lenStorageQuadTreeBox,sb);
+				if (!sb || (sb->bc->n != 0)){ISSMERROR("!sb || (sb->bc->n != 0)");}
+				NbQuadTreeBox++;
+				return sb->bc++;
+			}
+	};
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/R2.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/R2.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/R2.h	(revision 3913)
@@ -0,0 +1,104 @@
+/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, R2.h)*/
+#ifndef _R2_H
+#define _R2_H
+
+#include <cstdio>
+
+namespace bamg {
+
+	template <class R,class RR> class P2xP2;
+	template <class R,class RR>
+	  class P2 {
+		  public:  
+			  //fields
+			  R x,y;
+			  //functions
+			  P2 () :x(0),y(0) {};
+			  P2 (R a,R b)  :x(a),y(b)  {}
+			  P2 (P2 A,P2 B) : x(B.x-A.x),y(B.y-A.y) {}
+			  void Echo(){
+				  printf("Member of P2:\n");
+				  printf("   x: %g\n",x);
+				  printf("   y: %g\n",y);
+			  }
+			  //operators
+			  RR       operator,(const P2<R,RR> & cc) const {return  (RR) x* (RR) cc.x+(RR) y* (RR) cc.y;} //scalar product
+			  P2<R,RR> operator+(const P2<R,RR> & cc) const {return P2<R,RR>(x+cc.x,y+cc.y);}
+			  P2<R,RR> operator-(const P2<R,RR> & cc) const {return P2<R,RR>(x-cc.x,y-cc.y);}
+			  P2<R,RR> operator-()  const{return P2<R,RR>(-x,-y);}
+			  P2<R,RR> operator*(R  cc) const {return P2<R,RR>(x*cc,y*cc);}
+			  P2<R,RR> operator/(R  cc) const {return P2<R,RR>(x/cc,y/cc);}
+			  P2<R,RR> operator+=(const  P2<R,RR> & cc) {x += cc.x;y += cc.y;return *this;}
+			  P2<R,RR> operator/=(const  R r) {x /= r;y /= r;return *this;}
+			  P2<R,RR> operator*=(const  R r) {x *= r;y *= r;return *this;}
+			  P2<R,RR> operator-=(const  P2<R,RR> & cc) {x -= cc.x;y -= cc.y;return *this;}
+	  };
+
+	template <class R,class RR>
+	  class P2xP2 {
+		  private:
+			  friend P2<R,RR> operator*(P2<R,RR> c,P2xP2<R,RR> cc){
+				  return P2<R,RR>(c.x*cc.x.x + c.y*cc.y.x, c.x*cc.x.y + c.y*cc.y.y);
+			  } 
+		  public:
+			  //fields
+			  P2<R,RR> x,y; 
+			  //functions
+			  P2xP2 (): x(),y()  {}
+			  P2xP2 (P2<R,RR> a,P2<R,RR> b): x(a),y(b) {}
+			  P2xP2 (P2<R,RR> a,P2<R,RR> b,P2<R,RR> c ): x(b-a),y(c-a) {}
+			  P2xP2 (R xx,R xy,R yx,R yy) :x(xx,xy),y(yx,yy) {}
+			  void Echo(){
+				  printf("Member of P2xP2:\n");
+				  printf("   x.x: %g   x.y: %g\n",x.x,x.y);
+				  printf("   y.x: %g   y.x: %g\n",y.x,y.y);
+			  }
+			  RR          det() const {return (RR) x.x* (RR) y.y - (RR) x.y * (RR) y.x;}
+			  P2xP2<R,RR> inv()  const{
+				  RR d = (*this).det(); 
+				  return P2xP2<R,RR>((R)( y.y /d) ,(R)(-x.y/d),(R)( -y.x/d) ,(R)( x.x/d) );
+			  };
+			  P2xP2<R,RR> t()  {return P2xP2<R,RR>(x.x,y.x,x.y,y.y);} //transposer 
+			  P2<R,RR>    tx() {return P2<R,RR>(x.x,y.x);} 
+			  P2<R,RR>    ty() {return P2<R,RR>(x.y,y.y);} 
+			  //Operators
+			  P2<R,RR>     operator*(const P2<R,RR> c) const {return P2<R,RR>(x.x*c.x + x.y*c.y, y.x*c.x + y.y*c.y);}
+			  P2xP2<R,RR>  operator*(P2xP2<R,RR> c) const{
+				  return  P2xP2<R,RR>(x.x*c.x.x + x.y*c.y.x,
+							  x.x*c.x.y + x.y*c.y.y,
+							  y.x*c.x.x + y.y*c.y.x,
+							  y.x*c.x.y + y.y*c.y.y);
+			  }
+	  };  
+
+	//inline functions
+	template  <class R,class RR>  
+	  inline RR Det(const P2<R,RR> x,const P2<R,RR> y) {
+		  return (RR) x.x * (RR) y.y - (RR) x.y * (RR) y.x ;
+	  } 
+	template  <class R,class RR>  
+	  inline RR Area2 (const P2<R,RR> a,const P2<R,RR> b,const P2<R,RR> c) {
+		  return Det(b-a,c-a) ;
+	  }
+	template  <class R,class RR>  
+	  inline R Norme1 (const P2<R,RR> x) {
+		  return (Abs(x.x)+Abs(x.y)) ;
+	  } 
+	template  <class R,class RR>  
+	  inline R NormeInfini (const P2<R,RR> x) {
+		  return Max(Abs(x.x),Abs(x.y)) ;
+	  }
+	template  <class R,class RR>  
+	  inline RR Norme2_2 (const P2<R,RR> x) {
+		  return (RR)x.x*(RR)x.x + (RR)x.y*(RR)x.y ;
+	  } 
+	template  <class R,class RR>  
+	  inline RR Norme2 (const P2<R,RR> x) {
+		  return sqrt((RR)x.x*(RR)x.x + (RR)x.y*(RR)x.y) ;
+	  } 
+	template  <class R,class RR>  
+	  inline P2<R,RR> Orthogonal (const P2<R,RR> x) {
+		  return  P2<R,RR>(-x.y,x.x);
+	  } 
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/SetOfE4.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/SetOfE4.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/SetOfE4.cpp	(revision 3913)
@@ -0,0 +1,90 @@
+#include "../objects.h"
+
+using namespace std;
+namespace bamg {
+
+	/*Constructor*/
+	/*FUNCTION  SetOfEdges4::SetOfEdges4(long mmx,long nnx){{{1*/
+	SetOfEdges4::SetOfEdges4(long mmx,long nnx){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, SetOfEdges4.cpp/SetOfEdges4)*/
+
+		/*Intermediary*/
+		int i;
+
+		//initialize fields
+		nx   =nnx;   //number of vertices
+		nbax =mmx;   // 3 * number of triangles
+		NbOfEdges=0;
+		head = new long [nx];
+		Edges= new IntEdge[nbax];
+
+		//initialize head (-1 everywhere)
+		i=nx;
+		while(i--) head[i]=-1;
+	}
+	/*}}}1*/
+
+	/*Methods*/ 
+	/*FUNCTION  SetOfEdges4::find {{{1*/
+	long SetOfEdges4::find(long ii,long jj) { 
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, SetOfEdges4.cpp/find)*/
+
+		/*Intermediary*/
+		int n;
+
+		//check that head is not empty
+		ISSMASSERT(head);
+
+		//get n from h (usually h=ii)
+		n=head[Abs(ii)%nx];
+
+		//go through the existing edges that holds h (=ii) and return position in Edge
+		while (n >= 0){
+
+			//if the edge ii jj is already in Edges, return n
+			if (ii == Edges[n].i && jj == Edges[n].j) return n;
+
+			//else go to next edge that holds ii
+			else n = Edges[n].next;
+		}
+
+		//if we reach this point, the edge does not exist return -1
+		return -1;
+	}
+	/*}}}1*/
+	/*FUNCTION  SetOfEdges4::add{{{1*/
+	long SetOfEdges4::add(long ii,long jj) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, SetOfEdges4.cpp/add)*/
+
+		/*Intermediary*/
+		int h,n;
+
+		//get n from h (usually h=ii)
+		ISSMASSERT(head);
+		n=head[h=Abs(ii)%nx];
+
+		//go through the existing edges that holds h (=ii) and check that 
+		//the edge ii jj is not already in Edge
+		while (n >= 0){
+
+			//if the edge ii jj is already in Edges, return n
+			if (ii == Edges[n].i && jj == Edges[n].j) return n;
+
+			//else go to next edge that holds ii
+			else n = Edges[n].next;
+		}
+
+		//check that nbax <=NbOfEdges
+		if (nbax <=NbOfEdges ) {
+			ISSMERROR("SetOfEdges4::add overflow: NbOfEdges=%i > nbax=%i",NbOfEdges,nbax);
+		}
+
+		//update chain
+		Edges[NbOfEdges].i=ii;
+		Edges[NbOfEdges].j=jj;
+		Edges[NbOfEdges].next= head[h];
+		head[h] = NbOfEdges;
+		return NbOfEdges ++;
+	}
+	/*}}}1*/
+}
Index: issm/trunk/src/c/objects/Bamg/SetOfE4.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/SetOfE4.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/SetOfE4.h	(revision 3913)
@@ -0,0 +1,42 @@
+#ifndef _SetOfEdge4_h
+#define _SetOfEdge4_h
+
+namespace bamg {
+
+	class SetOfEdges4;
+
+	class IntEdge{
+		friend class SetOfEdges4;
+		public:
+		long i,j;
+		long next; 
+	};
+
+	class SetOfEdges4 {
+
+		private:
+			long nx,nbax,NbOfEdges;
+			long* head; 
+			IntEdge* Edges;
+
+		public:
+
+			// Constructors
+			SetOfEdges4(long ,long);// nb Edges mx , nb de sommet 
+			~SetOfEdges4() {delete [] head; delete [] Edges;}
+
+			//operators
+			IntEdge & operator[](long k){return  Edges[k];}
+
+			//Methods
+			long add (long ii,long jj);
+			long SortAndAdd (long ii,long jj) {return ii <=jj ? add (ii,jj)  : add (jj,ii) ;}
+			long nb(){return NbOfEdges;}
+			long find (long ii,long jj);
+			long SortAndFind (long ii,long jj) {return ii <=jj ? find (ii,jj)  : find (jj,ii) ;}
+			long i(long k){return Edges[k].i;}
+			long j(long k){return Edges[k].j;}
+			long newarete(long k){return NbOfEdges == k+1;}
+	};
+}
+#endif 
Index: issm/trunk/src/c/objects/Bamg/SubDomain.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/SubDomain.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/SubDomain.cpp	(revision 3913)
@@ -0,0 +1,28 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "SubDomain.h"
+#include "Triangles.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+
+	/*Methods*/
+	/*FUNCTION SubDomain::Set {{{1*/
+	void SubDomain::Set(const Triangles & Th ,long i,Triangles & ThNew){
+		*this = Th.subdomains[i];
+		if ( head-Th.triangles<0 || head-Th.triangles>=Th.nbt){
+			ISSMERROR("head-Th.triangles<0 || head-Th.triangles>=Th.nbt");
+		}
+		head = ThNew.triangles + Th.Number(head) ; 
+		if (edge-Th.edges<0 || edge-Th.edges>=Th.nbe);{
+			ISSMERROR("edge-Th.edges<0 || edge-Th.edges>=Th.nbe");
+		}
+		edge = ThNew.edges+ Th.Number(edge);
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/SubDomain.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/SubDomain.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/SubDomain.h	(revision 3913)
@@ -0,0 +1,25 @@
+#ifndef _SUBDOMAIN_H_
+#define _SUBDOMAIN_H_
+
+#include "./include.h"
+#include "./Edge.h"
+
+namespace bamg {
+
+	//classes
+	class Triangle;
+	class Triangles;
+
+	class SubDomain {
+		public:
+			Triangle * head;
+			long  ref;  
+			int sens; // -1 or 1
+			Edge* edge; // to  geometrical 	
+
+			//Methods
+			void Set(const Triangles &,long,Triangles &);
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/Triangle.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/Triangle.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Triangle.cpp	(revision 3913)
@@ -0,0 +1,328 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "../objects.h"
+
+namespace bamg {
+
+	/*Constructors/Destructors*/
+	/*FUNCTION Triangle(Triangles *Th,long i,long j,long k) {{{1*/
+	Triangle::Triangle(Triangles *Th,long i,long j,long k) {
+		MeshVertex *v=Th->vertices;
+		long nbv = Th->nbv;
+		if (i<0 || j<0 || k<0){
+			ISSMERROR("i<0 || j<0 || k<0");
+		}
+		if (i>=nbv || j>=nbv || k>=nbv){
+			ISSMERROR("i>=nbv || j>=nbv || k>=nbv");
+		}
+		TriaVertices[0]=v+i;
+		TriaVertices[1]=v+j;
+		TriaVertices[2]=v+k;
+		TriaAdjTriangles[0]=TriaAdjTriangles[1]=TriaAdjTriangles[2]=0;
+		TriaAdjSharedEdge[0]=TriaAdjSharedEdge[1]=TriaAdjSharedEdge[2]=0;
+		det=0;
+	}
+	/*}}}*/
+	/*FUNCTION Triangle(MeshVertex *v0,MeshVertex *v1,MeshVertex *v2) {{{1*/
+	Triangle::Triangle(MeshVertex *v0,MeshVertex *v1,MeshVertex *v2){
+		TriaVertices[0]=v0;
+		TriaVertices[1]=v1;
+		TriaVertices[2]=v2;
+		TriaAdjTriangles[0]=TriaAdjTriangles[1]=TriaAdjTriangles[2]=0;
+		TriaAdjSharedEdge[0]=TriaAdjSharedEdge[1]=TriaAdjSharedEdge[2]=0;
+		if (v0) det=0;
+		else {
+			det=-1;
+			link=NULL;};  
+	}
+	/*}}}*/
+
+	/*Methods*/
+	/*FUNCTION Triangle::Echo {{{1*/
+	void Triangle::Echo(void){
+
+		int i;
+
+		printf("Triangle:\n");
+		printf("   TriaVertices pointer towards three vertices\n");
+		printf("      TriaVertices[0] TriaVertices[1] TriaVertices[2] = %p %p %p\n",TriaVertices[0],TriaVertices[1],TriaVertices[2]);
+		printf("   TriaAdjTriangles pointer towards three adjacent triangles\n");
+		printf("      TriaAdjTriangles[0] TriaAdjTriangles[1] TriaAdjTriangles[2] = %p %p %p\n",TriaAdjTriangles[0],TriaAdjTriangles[1],TriaAdjTriangles[2]);
+		printf("   det (integer triangle determinant) = %i\n",det);
+		if (link){
+			printf("   link (pointer toward duplicate triangle)= %p\n",link);
+		}
+		else{
+			printf("   color = %i\n",color);
+		}
+
+		printf("\nThree vertices:\n");
+		for(i=0;i<3;i++){
+			if (TriaVertices[i]){
+				TriaVertices[i]->Echo();
+			}
+			else{
+				printf("   vertex %i does not exist\n",i+1);
+			}
+		}
+
+		return;
+	}
+	/*}}}*/
+	/*FUNCTION Triangle::FindBoundaryEdge{{{1*/
+	TriangleAdjacent Triangle::FindBoundaryEdge(int i) const{
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Mesh2.cpp/FindBoundaryEdge)*/
+
+		/*Intermediary*/
+		Triangle* ttc=NULL;
+		int k,j,jc;
+
+		// call current triangle t
+		Triangle* t = (Triangle*)this;
+
+		//is the current triangle inside or outside?
+		int outside=!link  ;
+
+		// EdgesVertexTriangle[3][2] = {{1,2},{2,0},{0,1}};
+		// initialize j as the first vertex of the ith edge
+		j=EdgesVertexTriangle[i][0];
+
+		//Loop over the adjacent triangle of t
+		k=0;
+		do{
+			//keep track of outside
+			int outsidep = outside;
+			//increment k
+			k++;
+			//Get ttc, adjacent triangle of t with respect to vertex j
+			ttc =  t->TriaAdjTriangles[j];
+			//is the current triangle inside or outside?
+			outside = !ttc->link;
+			//if both previous triangle are outside, return
+			if (outside+outsidep == 1) return TriangleAdjacent(t,j);
+
+			//update t and j
+			t = ttc;
+			//NextEdge[3] = {1,2,0};
+			jc = NextEdge[t->TriaAdjSharedEdge[j]&3];
+			j = NextEdge[jc];
+
+			//check number of iterations
+			if (k>=2000){
+				ISSMERROR("too many iteration in Triangle::FindBoundaryEdge (k>=2000)");
+			}
+		} while (this!= t);
+		//not found, return empty triangle
+		return TriangleAdjacent(NULL,0);
+	}
+	/*}}}1*/
+	/*FUNCTION Triangle::Optim{{{1*/
+	long  Triangle::Optim(short i,int koption) {
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Mesh2.cpp/Optim)*/
+
+		// turn around (positive direction)
+		Triangle *t=this;
+		long NbSwap =0;
+		int  k = 0;
+		int  j = OppositeEdge[i];
+		int  jp= PreviousEdge[j];
+
+		// initialize tp, jp the previous triangle & edge
+		Triangle *tp=TriaAdjTriangles[jp];
+		jp = TriaAdjSharedEdge[jp]&3;
+		do {
+			while (t->swap(j,koption)){
+				if (k>=20000) ISSMERROR("k>=20000");
+				NbSwap++;
+				k++;
+				t=  tp->TriaAdjTriangles[jp];      // set unchange t qnd j for previous triangles
+				j=  NextEdge[tp->TriaAdjSharedEdge[jp]&3];
+			}
+			// end on this  Triangle 
+			tp = t;
+			jp = NextEdge[j];
+
+			t=  tp->TriaAdjTriangles[jp];      // set unchange t qnd j for previous triangles
+			j=  NextEdge[tp->TriaAdjSharedEdge[jp]&3];
+
+		} while( t != this);
+		return NbSwap;
+	}
+	/*}}}1*/
+	/*FUNCTION Triangle::Quadrangle {{{1*/
+	Triangle* Triangle::Quadrangle(MeshVertex * & v0,MeshVertex * & v1,MeshVertex * & v2,MeshVertex * & v3) const{
+		// return the other triangle of the quad if a quad or 0 if not a quat
+		Triangle * t =0;
+		if (link) {
+			int a=-1;
+			if (TriaAdjSharedEdge[0] & 16 ) a=0;
+			if (TriaAdjSharedEdge[1] & 16 ) a=1;
+			if (TriaAdjSharedEdge[2] & 16 ) a=2;
+			if (a>=0) {
+				t = TriaAdjTriangles[a];
+				//  if (t-this<0) return 0;
+				v2 = TriaVertices[VerticesOfTriangularEdge[a][0]];
+				v0 = TriaVertices[VerticesOfTriangularEdge[a][1]];
+				v1 = TriaVertices[OppositeEdge[a]];
+				v3 = t->TriaVertices[OppositeEdge[TriaAdjSharedEdge[a]&3]];
+			}
+		}
+		return t;
+	}
+	/*}}}*/
+	/*FUNCTION Triangle::QualityQuad {{{1*/
+	double   Triangle::QualityQuad(int a,int option) const{
+		double q;
+		if (!link || TriaAdjSharedEdge[a] &4)
+		 q=  -1;
+		else {
+			Triangle * t = TriaAdjTriangles[a];
+			if (t-this<0) q=  -1;// because we do 2 times 
+			else if (!t->link ) q=  -1;
+			else if (TriaAdjSharedEdge[0] & 16 || TriaAdjSharedEdge[1] & 16  || TriaAdjSharedEdge[2] & 16 || t->TriaAdjSharedEdge[0] & 16 || t->TriaAdjSharedEdge[1] & 16 || t->TriaAdjSharedEdge[2] & 16 )
+			 q= -1;
+			else if(option){ 
+				const MeshVertex & v2 = *TriaVertices[VerticesOfTriangularEdge[a][0]];
+				const MeshVertex & v0 = *TriaVertices[VerticesOfTriangularEdge[a][1]];
+				const MeshVertex & v1 = *TriaVertices[OppositeEdge[a]];
+				const MeshVertex & v3 = * t->TriaVertices[OppositeEdge[TriaAdjSharedEdge[a]&3]];
+				q =  QuadQuality(v0,v1,v2,v3); // do the float part
+			}
+			else q= 1;
+		}
+		return  q;
+	}
+	/*}}}*/
+	/*FUNCTION Triangle::Set {{{1*/
+	void Triangle::Set(const Triangle & rec,const Triangles & Th ,Triangles & ThNew){ 
+		*this = rec;
+		if ( TriaVertices[0] ) TriaVertices[0] = ThNew.vertices +  Th.Number(TriaVertices[0]);
+		if ( TriaVertices[1] ) TriaVertices[1] = ThNew.vertices +  Th.Number(TriaVertices[1]);
+		if ( TriaVertices[2] ) TriaVertices[2] = ThNew.vertices +  Th.Number(TriaVertices[2]);
+		if(TriaAdjTriangles[0]) TriaAdjTriangles[0] =  ThNew.triangles + Th.Number(TriaAdjTriangles[0]);
+		if(TriaAdjTriangles[1]) TriaAdjTriangles[1] =  ThNew.triangles + Th.Number(TriaAdjTriangles[1]);
+		if(TriaAdjTriangles[2]) TriaAdjTriangles[2] =  ThNew.triangles + Th.Number(TriaAdjTriangles[2]);
+		if (link  >= Th.triangles && link  < Th.triangles + Th.nbt)
+		 link = ThNew.triangles + Th.Number(link);
+	}
+	/*}}}*/
+	/*FUNCTION Triangle::swap{{{1*/
+	int Triangle::swap(short a,int koption){
+		/*Original code from Frederic Hecht <hecht@ann.jussieu.fr> (BAMG v1.01, Mesh2.cpp/swap)*/
+
+		if(a/4 !=0) return 0;// arete lock or MarkUnSwap
+
+		register Triangle *t1=this,*t2=TriaAdjTriangles[a];// les 2 triangles adjacent
+		register short a1=a,a2=TriaAdjSharedEdge[a];// les 2 numero de l arete dans les 2 triangles
+		if(a2/4 !=0) return 0; // arete lock or MarkUnSwap
+
+		register MeshVertex  *sa=t1->TriaVertices[VerticesOfTriangularEdge[a1][0]];
+		register MeshVertex  *sb=t1->TriaVertices[VerticesOfTriangularEdge[a1][1]];
+		register MeshVertex  *s1=t1->TriaVertices[OppositeVertex[a1]];
+		register MeshVertex  *s2=t2->TriaVertices[OppositeVertex[a2]];
+
+		Icoor2 det1=t1->det , det2=t2->det ;
+		Icoor2 detT = det1+det2;
+		Icoor2 detA = Abs(det1) + Abs(det2);
+		Icoor2 detMin = Min(det1,det2);
+
+		int OnSwap = 0;       
+		// si 2 triangle infini (bord) => detT = -2;
+		if (sa == 0) {// les deux triangles sont frontieres
+			det2=bamg::det(s2->i,sb->i,s1->i);
+			OnSwap = det2 >0;}
+		else if (sb == 0) { // les deux triangles sont frontieres
+			det1=bamg::det(s1->i,sa->i,s2->i);
+			OnSwap = det1 >0;}
+		else if(( s1 != 0) && (s2 != 0) ) {
+			det1 = bamg::det(s1->i,sa->i,s2->i);
+			det2 = detT - det1;
+			OnSwap = (Abs(det1) + Abs(det2)) < detA;
+
+			Icoor2 detMinNew=Min(det1,det2);
+			//     if (detMin<0 && (Abs(det1) + Abs(det2) == detA)) OnSwap=BinaryRand();// just for test   
+			if (! OnSwap &&(detMinNew>0)) {
+				OnSwap = detMin ==0;
+				if (! OnSwap) {
+					int  kopt = koption;
+					while (1)
+					 if(kopt) {
+						 // critere de Delaunay pure isotrope
+						 register Icoor2 xb1 = sb->i.x - s1->i.x,
+									 x21 = s2->i.x - s1->i.x,
+									 yb1 = sb->i.y - s1->i.y,
+									 y21 = s2->i.y - s1->i.y,
+									 xba = sb->i.x - sa->i.x, 
+									 x2a = s2->i.x - sa->i.x,
+									 yba = sb->i.y - sa->i.y,
+									 y2a = s2->i.y - sa->i.y;
+						 register double
+							cosb12 =  double(xb1*x21 + yb1*y21),
+									 cosba2 =  double(xba*x2a + yba*y2a) ,
+									 sinb12 = double(det2),
+									 sinba2 = double(t2->det);
+
+
+						 // angle b12 > angle ba2 => cotg(angle b12) < cotg(angle ba2)
+						 OnSwap =  ((double) cosb12 * (double)  sinba2) <  ((double) cosba2 * (double) sinb12);
+						 break;
+					 }
+					 else {	
+						 // critere de Delaunay anisotrope 
+						 double som;
+						 I2 AB=(I2) *sb - (I2) *sa;
+						 I2 MAB2=((I2) *sb + (I2) *sa);
+						 R2 MAB(MAB2.x*0.5,MAB2.y*0.5);
+						 I2 A1=(I2) *s1 - (I2) *sa;
+						 I2 D = (I2) * s1 - (I2) * sb ;
+						 R2 S2(s2->i.x,s2->i.y);
+						 R2 S1(s1->i.x,s1->i.y);
+							{
+							 Metric M=s1->m;
+							 R2 ABo = M.Orthogonal(AB);
+							 R2 A1o = M.Orthogonal(A1);
+							 // (A+B)+ x ABo = (S1+B)/2+ y A1 
+							 // ABo x - A1o y =  (S1+B)/2-(A+B)/2 = (S1-B)/2 = D/2
+							 double dd = Abs(ABo.x*A1o.y)+Abs(ABo.y*A1o.x);
+							 double d = (ABo.x*A1o.y - ABo.y*A1o.x)*2; // because D/2
+							 if (Abs(d) > dd*1.e-3) {
+								 R2 C(MAB+ABo*((D.x*A1o.y - D.y*A1o.x)/d));
+								 som  = M(C - S2)/M(C - S1);
+							 } else 
+								{kopt=1;continue;}
+
+							}
+							{
+							 Metric M=s2->m;
+							 R2 ABo = M.Orthogonal(AB);
+							 R2 A1o = M.Orthogonal(A1);
+							 // (A+B)+ x ABo = (S1+B)/2+ y A1 
+							 // ABo x - A1o y =  (S1+B)/2-(A+B)/2 = (S1-B)/2 = D/2 
+							 double dd = Abs(ABo.x*A1o.y)+Abs(ABo.y*A1o.x);
+							 double d = (ABo.x*A1o.y - ABo.y*A1o.x)*2; // because D/2
+							 if(Abs(d) > dd*1.e-3) {
+								 R2 C(MAB+ABo*((D.x*A1o.y - D.y*A1o.x)/d));
+								 som  += M(C - S2)/M(C -  S1);
+							 } else 
+								{kopt=1;continue;}
+							}
+						 OnSwap = som < 2;
+						 break;
+					 }
+
+				} // OnSwap 
+			} // (! OnSwap &&(det1 > 0) && (det2 > 0) )
+		}
+		if( OnSwap ) 
+		 bamg::swap(t1,a1,t2,a2,s1,s2,det1,det2);
+		else {
+			t1->SetMarkUnSwap(a1);     
+		}
+		return OnSwap;
+	}
+	/*}}}1*/
+
+}
Index: issm/trunk/src/c/objects/Bamg/Triangle.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/Triangle.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/Triangle.h	(revision 3913)
@@ -0,0 +1,125 @@
+#ifndef _TRIANGLE_H_
+#define _TRIANGLE_H_
+
+#include "./include.h"
+#include "TriangleAdjacent.h"
+
+namespace bamg {
+
+	//classes
+	class Triangles;
+	class MeshVertex;
+	class Triangle;
+
+	class Triangle {
+
+		friend class TriangleAdjacent;
+
+		private:
+			MeshVertex*   TriaVertices[3];      // 3 vertices if t is triangle, t[i] allowed by access function, (*t)[i] if pointer
+			Triangle* TriaAdjTriangles[3];  // 3 pointers toward the adjacent triangles
+			short     TriaAdjSharedEdge[3]; // number of the edges in the adjacent triangles the edge number 1 is the edge number TriaAdjSharedEdge[1] in the Adjacent triangle 1
+
+		public: 
+			Icoor2 det; // determinant du triangle (2 fois l aire des vertices entieres)
+			union { 
+				Triangle * link ;
+				long color;
+			};
+
+			//Constructors/Destructors
+			Triangle() {}
+			Triangle(Triangles *Th,long i,long j,long k);
+			Triangle(MeshVertex *v0,MeshVertex *v1,MeshVertex *v2);
+
+			//Operators
+			const MeshVertex & operator[](int i) const {return *TriaVertices[i];};
+			MeshVertex & operator[](int i)  {return *TriaVertices[i];};
+			const MeshVertex * operator()(int i) const {return TriaVertices[i];};
+			MeshVertex * & operator()(int i)  {return TriaVertices[i];};
+
+			//Methods
+			void   Echo();
+			int    swap(short a1,int=0);
+			long   Optim(short a,int =0);
+			int    Locked(int a)const { return TriaAdjSharedEdge[a]&4;} 
+			int    Hidden(int a)const { return TriaAdjSharedEdge[a]&16;} 
+			int    GetAllflag(int a){return TriaAdjSharedEdge[a] & 1020;}
+			void   SetAllFlag(int a,int f){TriaAdjSharedEdge[a] = (TriaAdjSharedEdge[a] &3) + (1020 & f);}
+			double QualityQuad(int a,int option=1) const;
+			short  NuEdgeTriangleAdj(int i) const {return TriaAdjSharedEdge[i&3]&3;} // Number of the  adjacent edge in adj tria  
+			TriangleAdjacent FindBoundaryEdge(int i) const;
+			TriangleAdjacent Adj(int i)  const {return TriangleAdjacent(TriaAdjTriangles[i],TriaAdjSharedEdge[i]&3);};
+			Triangle* TriangleAdj(int i) const {return TriaAdjTriangles[i&3];}
+			Triangle* Quadrangle(MeshVertex * & v0,MeshVertex * & v1,MeshVertex * & v2,MeshVertex * & v3) const ;
+			void  ReNumbering(Triangle *tb,Triangle *te, long *renu){
+				if (link  >=tb && link  <te) link  = tb + renu[link -tb];
+				if (TriaAdjTriangles[0] >=tb && TriaAdjTriangles[0] <te) TriaAdjTriangles[0] = tb + renu[TriaAdjTriangles[0]-tb];
+				if (TriaAdjTriangles[1] >=tb && TriaAdjTriangles[1] <te) TriaAdjTriangles[1] = tb + renu[TriaAdjTriangles[1]-tb];
+				if (TriaAdjTriangles[2] >=tb && TriaAdjTriangles[2] <te) TriaAdjTriangles[2] = tb + renu[TriaAdjTriangles[2]-tb];    
+			}
+			void ReNumbering(MeshVertex *vb,MeshVertex *ve, long *renu){
+				if (TriaVertices[0] >=vb && TriaVertices[0] <ve) TriaVertices[0] = vb + renu[TriaVertices[0]-vb];
+				if (TriaVertices[1] >=vb && TriaVertices[1] <ve) TriaVertices[1] = vb + renu[TriaVertices[1]-vb];
+				if (TriaVertices[2] >=vb && TriaVertices[2] <ve) TriaVertices[2] = vb + renu[TriaVertices[2]-vb];    
+			}
+			void SetAdjAdj(short a){
+				a &= 3;
+				register Triangle *tt=TriaAdjTriangles[a];
+				TriaAdjSharedEdge [a] &= 55; // remove MarkUnSwap
+				register short aatt = TriaAdjSharedEdge[a] & 3;
+				if(tt){ 
+					tt->TriaAdjTriangles[aatt]=this;
+					tt->TriaAdjSharedEdge[aatt]=a + (TriaAdjSharedEdge[a] & 60 ) ;}// Copy all the mark 
+			  }
+			void SetAdj2(short a,Triangle *t,short aat){
+				TriaAdjTriangles[a]=t;    //the adjacent triangle to the edge a is t
+				TriaAdjSharedEdge[a]=aat; //position of the edge in the adjacent triangle
+				if(t) { //if t!=NULL add adjacent triangle to t (this)
+					t->TriaAdjTriangles[aat]=this;
+					t->TriaAdjSharedEdge[aat]=a;
+				}
+			}
+			void SetTriangleContainingTheVertex() { 
+				if (TriaVertices[0]) (TriaVertices[0]->t=this,TriaVertices[0]->vint=0);
+				if (TriaVertices[1]) (TriaVertices[1]->t=this,TriaVertices[1]->vint=1);
+				if (TriaVertices[2]) (TriaVertices[2]->t=this,TriaVertices[2]->vint=2);
+			}
+			void SetHidden(int a){
+				//Get Adjacent Triangle number a
+				register Triangle* t = TriaAdjTriangles[a];
+				//if it exist
+				//C|=D -> C=(C|D) bitwise inclusive OR
+				if(t) t->TriaAdjSharedEdge[TriaAdjSharedEdge[a] & 3] |=16;
+				TriaAdjSharedEdge[a] |= 16;
+			}
+
+			void SetLocked(int a){
+				//mark the edge as on Boundary
+				register Triangle * t = TriaAdjTriangles[a];
+				t->TriaAdjSharedEdge[TriaAdjSharedEdge[a] & 3] |=4;
+				TriaAdjSharedEdge[a] |= 4;
+			}
+			void SetMarkUnSwap(int a){
+				register Triangle * t = TriaAdjTriangles[a];
+				t->TriaAdjSharedEdge[TriaAdjSharedEdge[a] & 3] |=8;
+				TriaAdjSharedEdge[a] |=8 ;
+			}
+			void SetUnMarkUnSwap(int a){ 
+				register Triangle * t = TriaAdjTriangles[a];
+				t->TriaAdjSharedEdge[TriaAdjSharedEdge[a] & 3] &=55; // 23 + 32 
+				TriaAdjSharedEdge[a] &=55 ;
+			}
+			void SetDet() {
+				if(TriaVertices[0] && TriaVertices[1] && TriaVertices[2])    det = bamg::det(*TriaVertices[0],*TriaVertices[1],*TriaVertices[2]);
+				else det = -1; }
+
+			//Inline methods
+			double qualite() ;
+			void  Set(const Triangle &,const Triangles &,Triangles &);
+			int   In(MeshVertex *v) const { return TriaVertices[0]==v || TriaVertices[1]==v || TriaVertices[2]==v ;}
+
+	};
+
+}
+#endif
Index: issm/trunk/src/c/objects/Bamg/TriangleAdjacent.cpp
===================================================================
--- issm/trunk/src/c/objects/Bamg/TriangleAdjacent.cpp	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/TriangleAdjacent.cpp	(revision 3913)
@@ -0,0 +1,76 @@
+#include <cstdio>
+#include <cstring>
+#include <cmath>
+#include <ctime>
+
+#include "TriangleAdjacent.h"
+#include "Triangles.h"
+
+namespace bamg {
+
+
+	/*Constructors/Destructors*/
+	//See header file
+
+	/*Methods*/
+	/*FUNCTION TriangleAdjacent::Locked {{{1*/
+	int  TriangleAdjacent::Locked() const {
+		return t->TriaAdjSharedEdge[a] & 4;
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::MarkUnSwap {{{1*/
+	int  TriangleAdjacent::MarkUnSwap() const {
+		return t->TriaAdjSharedEdge[a] & 8;
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::GetAllFlag_UnSwap {{{1*/
+	int  TriangleAdjacent::GetAllFlag_UnSwap() const {
+		// take all flag except MarkUnSwap
+		return t->TriaAdjSharedEdge[a] & 1012;
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::SetLock {{{1*/
+	void TriangleAdjacent::SetLock(){
+		t->SetLocked(a);
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::Adj {{{1*/
+	TriangleAdjacent TriangleAdjacent::Adj() const {
+		return  t->Adj(a);
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::EdgeVertex {{{1*/
+	MeshVertex* TriangleAdjacent::EdgeVertex(const int & i) const {
+		return t->TriaVertices[VerticesOfTriangularEdge[a][i]];
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::OppositeVertex {{{1*/
+	MeshVertex* TriangleAdjacent::OppositeVertex() const {
+		return t->TriaVertices[bamg::OppositeVertex[a]]; 
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::det {{{1*/
+	Icoor2 & TriangleAdjacent::det() const {
+		return t->det;
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::swap {{{1*/
+	int TriangleAdjacent::swap(){
+		return  t->swap(a);
+	}
+	/*}}}*/
+	/*FUNCTION TriangleAdjacent::SetAdj2 {{{1*/
+	void TriangleAdjacent::SetAdj2(const TriangleAdjacent & ta, int l  ){
+		//set Adjacent Triangle of a triangle
+		if(t) {
+			t->TriaAdjTriangles[a]=ta.t;
+			t->TriaAdjSharedEdge[a]=ta.a|l;
+		}
+		if(ta.t) {
+			ta.t->TriaAdjTriangles[ta.a] = t ;
+			ta.t->TriaAdjSharedEdge[ta.a] = a| l ;
+		}
+	}
+	/*}}}*/
+
+} 
Index: issm/trunk/src/c/objects/Bamg/TriangleAdjacent.h
===================================================================
--- issm/trunk/src/c/objects/Bamg/TriangleAdjacent.h	(revision 3913)
+++ issm/trunk/src/c/objects/Bamg/TriangleAdjacent.h	(revision 3913)
@@ -0,0 +1,46 @@
+#ifndef _TRIANGLEADJACENT_H_
+#define _TRIANGLEADJACENT_H_
+
+#include "./include.h"
+#include "./MeshVertex.h"
+
+namespace bamg {
+
+	//classes
+	class Triangle;
+	class Triangle;
+
+	class TriangleAdjacent {
+
+		public:
+			Triangle* t; //pointer toward the triangle
+			int  a;      //Edge number
+
+			//Constructors
+			TriangleAdjacent() {};
+			TriangleAdjacent(Triangle* tt,int  aa): t(tt),a(aa &3) {};
+
+			//Operators
+			operator Triangle * () const {return t;}
+			operator Triangle & () const {return *t;}
+			operator int() const {return a;}
+			TriangleAdjacent & operator++(){ a= NextEdge[a]; return *this; }
+			TriangleAdjacent operator--(){ a= PreviousEdge[a]; return *this; }
+
+			//Methods
+
+			//Methods
+			int  Locked() const;
+			int  MarkUnSwap() const;
+			int  GetAllFlag_UnSwap() const;
+			void SetLock();
+			void SetAdj2(const TriangleAdjacent &ta, int l=0);
+			int  swap();
+			TriangleAdjacent Adj() const;
+			MeshVertex* EdgeVertex(const int & i) const;
+			MeshVertex* OppositeVertex() const;
+			Icoor2& det() const;
+	};
+}
+#endif
+
